<?php
class ControllerextensionModuleyscrollup extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/module/yscrollup');

		$this->document->setTitle(preg_replace('/<(.*?)strong>/i', '', $this->language->get('heading_title')));

		$this->load->model('extension/module');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			if (!isset($this->request->get['module_id'])) {
				$this->model_extension_module->addModule('yscrollup', $this->request->post);
			} else {
				$this->model_extension_module->editModule($this->request->get['module_id'], $this->request->post);
			}

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=module', true));
		}

		$data['heading_title'] = preg_replace('/<(.*?)strong>/i', '', $this->language->get('heading_title'));

		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');

		$data['entry_name'] = $this->language->get('entry_name');
		$data['entry_status'] = $this->language->get('entry_status');
		$data['entry_scrollupi'] = $this->language->get('entry_scrollupi');
		$data['entry_scrollupb'] = $this->language->get('entry_scrollupb');
		$data['entry_scrollupr'] = $this->language->get('entry_scrollupr');
		$data['entry_scrollupw'] = $this->language->get('entry_scrollupw');
		$data['entry_scrolluph'] = $this->language->get('entry_scrolluph');
		$data['entry_scrolluprad'] = $this->language->get('entry_scrolluprad');
		$data['entry_scrolluprcss'] = $this->language->get('entry_scrolluprcss');
		$data['entry_scrollupback'] = $this->language->get('entry_scrollupback');
		$data['entry_suhover'] = $this->language->get('entry_suhover');
		$data['entry_suhcolor'] = $this->language->get('entry_suhcolor');
		$data['entry_suhback'] = $this->language->get('entry_suhback');
		$data['entry_scrollupbd'] = $this->language->get('entry_scrollupbd');
		$data['entry_scrollupbc'] = $this->language->get('entry_scrollupbc');
		
		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->error['name'])) {
			$data['error_name'] = $this->error['name'];
		} else {
			$data['error_name'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], 'SSL')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_module'),
			'href' => $this->url->link('extension/extension', 'token=' . $this->session->data['token'], 'SSL')
		);

		if (!isset($this->request->get['module_id'])) {
			$data['breadcrumbs'][] = array(
				'text' => preg_replace('/<(.*?)strong>/i', '', $this->language->get('heading_title')),
				'href' => $this->url->link('extension/module/yscrollup', 'token=' . $this->session->data['token'], 'SSL')
			);
		} else {
			$data['breadcrumbs'][] = array(
				'text' => preg_replace('/<(.*?)strong>/i', '', $this->language->get('heading_title')),
				'href' => $this->url->link('extension/module/yscrollup', 'token=' . $this->session->data['token'] . '&module_id=' . $this->request->get['module_id'], 'SSL')
			);
		}

		if (!isset($this->request->get['module_id'])) {
			$data['action'] = $this->url->link('extension/module/yscrollup', 'token=' . $this->session->data['token'], 'SSL');
		} else {
			$data['action'] = $this->url->link('extension/module/yscrollup', 'token=' . $this->session->data['token'] . '&module_id=' . $this->request->get['module_id'], 'SSL');
		}

		$data['cancel'] = $this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=module', true);

		if (isset($this->request->get['module_id']) && ($this->request->server['REQUEST_METHOD'] != 'POST')) {
			$module_info = $this->model_extension_module->getModule($this->request->get['module_id']);
		}

		if (isset($this->request->post['name'])) {
			$data['name'] = $this->request->post['name'];
		} elseif (!empty($module_info)) {
			$data['name'] = $module_info['name'];
		} else {
			$data['name'] = '';
		}
		if (isset($this->request->post['scrollupb'])) {
			$data['scrollupb'] = $this->request->post['scrollupb'];
		} elseif (!empty($module_info)) {
			$data['scrollupb'] = $module_info['scrollupb'];
		} else {
			$data['scrollupb'] = '15';
		}
		if (isset($this->request->post['scrollupr'])) {
			$data['scrollupr'] = $this->request->post['scrollupr'];
		} elseif (!empty($module_info)) {
			$data['scrollupr'] = $module_info['scrollupr'];
		} else {
			$data['scrollupr'] = '15';
		}	
		if (isset($this->request->post['scrollupw'])) {
			$data['scrollupw'] = $this->request->post['scrollupw'];
		} elseif (!empty($module_info)) {
			$data['scrollupw'] = $module_info['scrollupw'];
		} else {
			$data['scrollupw'] = '35';
		}
		if (isset($this->request->post['scrolluph'])) {
			$data['scrolluph'] = $this->request->post['scrolluph'];
		} elseif (!empty($module_info)) {
			$data['scrolluph'] = $module_info['scrolluph'];
		} else {
			$data['scrolluph'] = '35';
		}
		if (isset($this->request->post['scrolluprad'])) {
			$data['scrolluprad'] = $this->request->post['name'];
		} elseif (!empty($module_info)) {
			$data['scrolluprad'] = $module_info['scrolluprad'];
		} else {
			$data['scrolluprad'] = '5';
		}
		if (isset($this->request->post['scrolluprcss'])) {
			$data['scrolluprcss'] = $this->request->post['scrolluprcss'];
		} elseif (!empty($module_info)) {
			$data['scrolluprcss'] = $module_info['scrolluprcss'];
		} else {
			$data['scrolluprcss'] = '#000000';
		}
		if (isset($this->request->post['scrollupback'])) {
			$data['scrollupback'] = $this->request->post['scrollupback'];
		} elseif (!empty($module_info)) {
			$data['scrollupback'] = $module_info['scrollupback'];
		} else {
			$data['scrollupback'] = 'rgba(255,255,255,1)';
		}
		if (isset($this->request->post['suhcolor'])) {
			$data['suhcolor'] = $this->request->post['suhcolor'];
		} elseif (!empty($module_info)) {
			$data['suhcolor'] = $module_info['suhcolor'];
		} else {
			$data['suhcolor'] = '#ffffff';
		}
		if (isset($this->request->post['suhback'])) {
			$data['suhback'] = $this->request->post['name'];
		} elseif (!empty($module_info)) {
			$data['suhback'] = $module_info['suhback'];
		} else {
			$data['suhback'] = '#000000';
		}
		if (isset($this->request->post['scrollupbd'])) {
			$data['scrollupbd'] = $this->request->post['scrollupbd'];
		} elseif (!empty($module_info)) {
			$data['scrollupbd'] = $module_info['scrollupbd'];
		} else {
			$data['scrollupbd'] = '';
		}
		if (isset($this->request->post['scrollupbc'])) {
			$data['scrollupbc'] = $this->request->post['name'];
		} elseif (!empty($module_info)) {
			$data['scrollupbc'] = $module_info['scrollupbc'];
		} else {
			$data['scrollupbc'] = '';
		}
		if (isset($this->request->post['status'])) {
			$data['status'] = $this->request->post['status'];
		} elseif (!empty($module_info)) {
			$data['status'] = $module_info['status'];
		} else {
			$data['status'] = '';
		}

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/module/yscrollup.tpl', $data));
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'extension/module/yscrollup')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if ((utf8_strlen($this->request->post['name']) < 3) || (utf8_strlen($this->request->post['name']) > 64)) {
			$this->error['name'] = $this->language->get('error_name');
		}


		return !$this->error;
	}
}
